// 计算 computed
const calcComputed = function () {
    const data = this.data = this.data || {}
    const computed = data._computed || {}
    const computedKeys = Object.keys(computed)
    const needUpdate = {}

    for (let i = 0, len = computedKeys.length; i < len; i++) {
        const key = computedKeys[i]
        const getter = computed[key]

        if (typeof getter === 'function') {
            const value = getter.call(this)

            this._computedCache = this._computedCache || {}
            if (this._computedCache[key] !== value) {
                needUpdate[key] = value
                this._computedCache[key] = value
            }
        }
    }

    return needUpdate
}

module.exports = Behavior({
    lifetimes: {
        attached() {
            this._originalSetData = this.setData
            this.setData = this._setData
            this.setData({})
        }
    },
    definitionFilter(defFields) {
        const computed = defFields.computed || {}

        defFields.data = defFields.data || {}
        defFields.data._computed = computed

        defFields.methods = defFields.methods || {}
        defFields.methods._setData = function (data, callback) {
            const originalSetData = this._originalSetData

            if (this._doingSetData) {
                // eslint-disable-next-line no-console
                console.warn('can\'t call setData in computed getter function!')
                return
            }

            this._doingSetData = true

            // TODO 过滤掉 data 中的 computed 字段
            const dataKeys = Object.keys(data)
            for (let i = 0, len = dataKeys.length; i < len; i++) {
                const key = dataKeys[i]

                if (computed[key]) delete data[key]
            }

            // 做 data 属性的 setData
            originalSetData.call(this, data, callback)

            // 计算 computed
            const needUpdate = calcComputed.call(this)

            // 做 computed 属性的 setData
            originalSetData.call(this, needUpdate)

            this._doingSetData = false
        }
    }
})
